<?php
session_start();
$token = "tkn_" . rand(10000, 44555554);
$_SESSION["token"] = $token;
$vidlock_wp_path = explode('wp-content', dirname(__FILE__));
require($vidlock_wp_path[0] . '/wp-load.php');
$campaign_id = intval($_GET['id']);
$cpengage_ar_campaign_table_name = "{$wpdb->prefix}cpengage_ar_campaign";
$cpengage_campaign_table_name = "{$wpdb->prefix}cpengage_campaign";
$cpengage_pop_table_name = "{$wpdb->prefix}cpengage_pop";
$cpengage_pop_object_table_name = "{$wpdb->prefix}cpengage_pop_object";
$campaign_query = $wpdb->get_results("
	SELECT
		*
	FROM
		$cpengage_campaign_table_name AS campaign
	LEFT JOIN $cpengage_ar_campaign_table_name AS ar_campaign ON (campaign.arc_id = ar_campaign.arc_id)
	LEFT JOIN $cpengage_pop_table_name AS pop ON (campaign.pop_id = pop.pop_id)
	WHERE campaign_id IN ($campaign_id)
");
if (!function_exists('vidlock_json_encode_utf8'))
{
	function vidlock_json_encode_utf8($json)
	{
		return preg_replace_callback('/\\\\u(\w{4})/', function ($matches) {
		    return html_entity_decode('&#x' . $matches[1] . ';', ENT_COMPAT, 'UTF-8');
		}, json_encode($json));
	}
}
if (count($campaign_query) > 0)
{
	$campaign_data = array();
	$campaign = $campaign_query[0];
	if ($campaign->page_or_post == 'post')
	{
		$campaign_data['iframe_url'] = get_permalink($campaign->post_id);
	}
	else if ($campaign->page_or_post == 'page_url')
	{
		$campaign_data['iframe_url'] = $campaign->page_url;
	}
	else
	{
		echo '<pre>#cpengageError: There was something wrong in campaign settings.</pre>';
		exit;
	}
	// get primary pop objects
	$head_pop_objects = array();
	$pop_objects = $wpdb->get_results("SELECT * FROM $cpengage_pop_object_table_name WHERE pop_id IN (" . $campaign->pop_id . ") ");
	foreach ($pop_objects as $pop_object)
	{
		$pop_object->object_data = trim(preg_replace('/\s+/', ' ', $pop_object->object_data));
		$object_data = json_decode($pop_object->object_data, false);
		array_push($head_pop_objects, $object_data);
	}
	$head_pop_objects_data = vidlock_json_encode_utf8($head_pop_objects);
	// thank you message
	$campaign->thankyoumsg_text = str_replace('"', '\"', $campaign->thankyoumsg_text);
	// user ip
	if (!empty($_SERVER['HTTP_CLIENT_IP']))
	{
	    $cpengage_ip = $_SERVER['HTTP_CLIENT_IP'];
	}
	elseif (!empty($_SERVER['HTTP_X_FORWARDED_FOR']))
	{
	    $cpengage_ip = $_SERVER['HTTP_X_FORWARDED_FOR'];
	}
	else
	{
	    $cpengage_ip = $_SERVER['REMOTE_ADDR'];
	}
}
else
{
	echo '<pre>#cpengageError: Campaign not found.</pre>';
	exit;
}
?>
<!DOCTYPE html>
<html>
<head>
	<title><?php echo $campaign->page_title; ?></title>
	<meta itemprop="name" content="<?php echo htmlspecialchars($campaign->page_title); ?>"/>
	<meta itemprop="description" content="<?php echo htmlspecialchars($campaign->page_description); ?>"/>
	<meta itemprop="image" content="<?php echo htmlspecialchars($campaign->page_image); ?>"/>
	<meta name="twitter:title" content="<?php echo htmlspecialchars($campaign->page_title); ?>">
	<meta name="twitter:description" content="<?php echo htmlspecialchars($campaign->page_description); ?>"/>
	<meta name="twitter:image:src" content="<?php echo htmlspecialchars($campaign->page_image); ?>"/>
	<meta property="og:title" content="<?php echo htmlspecialchars($campaign->page_title); ?>"/>
	<meta property="og:description" content="<?php echo htmlspecialchars($campaign->page_description); ?>"/>
	<meta property="og:image" content="<?php echo htmlspecialchars($campaign->page_image); ?>"/>
	<meta property="og:url" content="<?php echo htmlspecialchars($campaign_data['iframe_url']); ?>"/>
	<link rel='stylesheet' href='pop_css.css' type='text/css' media='all' />
	<script src="jquery-1.11.3.js"></script>
	<script type="text/javascript">
	var pop_data = <?php echo $campaign->pop_settings; ?>;
	var pop_objects = <?php echo $head_pop_objects_data; ?>;
	var pop_type = '<?php echo $campaign->pop_type; ?>';
	var pop_position = '<?php echo $campaign->pop_position; ?>';
	var pop_duration_btwn_close = <?php echo intval($campaign->duration_btwn_close); ?>;
	var pop_id_auto_inc = 1;
	var campaign_id = <?php echo intval($campaign->campaign_id); ?>;
	var cpengage_ip = "<?php echo $cpengage_ip; ?>";
	var token = "<?php echo $token; ?>";
	var pop_for_email_subscriptions = <?php echo intval($campaign->arc_id); ?>;
	var name_object_id = pop_data.name_field_id;
	var email_object_id = pop_data.email_field_id;
	var thankyoumsg_type = '<?php echo $campaign->thankyoumsg_type; ?>';
	var thankyoumsg_text = "<?php echo $campaign->thankyoumsg_text; ?>";
	var thankyoumsg_redirect_url = "<?php echo htmlspecialchars($campaign->thankyoumsg_redirect_url); ?>";
	</script>
	<script type="text/javascript" src="pop_javascript.js"></script>
</head>
<body>
<div id="thankyoumsg-background" class="pop-background"></div>
<div id="thankyoumsg" class="pop">
	<div id="loader">
		<div style="height: 50px">&nbsp;</div>
		<img src="images/loader.gif" /><br />Loading...
	</div>
	<div id="success">
		<div style="height: 10px">&nbsp;</div>
		<img src="images/1433548766_success.png" />
		<div style="height: 80px; overflow: auto;">
			<?php echo $campaign->thankyoumsg_text; ?>
		</div>
		<div style="height: 10px">&nbsp;</div>
		<a href="#" id="thankyou-msg-close" onclick="return false;">Close[X]</a>
	</div>
</div>
<div id="pop-background" class="pop-background"></div>
<div id="pop" class="pop">
	<img src="images/cpengage_close.png" id="pop-close" class="pop-close" />
</div>
<div class="wrapper">
    <div class="h_iframe">
        <iframe id="campaign-iframe" src="<?php echo $campaign_data['iframe_url']; ?>" frameborder="0" allowfullscreen></iframe>
    </div>
</div>
</body>
</html>