var create_new_pop = function(div, pop_data)
{
	// apply style to the pop
	$('#' + div).css({
		'width': pop_data.width,
		'height': pop_data.height,
		'background-color': pop_data.background,
		'background-image': 'url("' + pop_data.background_url + '")',
		'border-width': pop_data.border_size,
		'border-style': pop_data.border_style,
		'border-color': pop_data.border_color,
		'-moz-border-radius-topleft': pop_data.border_top_left_corner + 'px', '-webkit-border-top-left-radius': pop_data.border_top_left_corner + 'px', 'border-top-left-radius': pop_data.border_top_left_corner + 'px',
		'-moz-border-radius-topright': pop_data.border_top_right_corner + 'px', '-webkit-border-top-right-radius': pop_data.border_top_right_corner + 'px', 'border-top-right-radius': pop_data.border_top_right_corner + 'px',
		'-moz-border-radius-bottomleft': pop_data.border_bottom_left_corner + 'px', '-webkit-border-bottom-left-radius': pop_data.border_bottom_left_corner + 'px', 'border-bottom-left-radius': pop_data.border_bottom_left_corner + 'px',
		'-moz-border-radius-bottomright': pop_data.border_bottom_right_corner + 'px', '-webkit-border-bottom-right-radius': pop_data.border_bottom_right_corner + 'px', 'border-bottom-right-radius': pop_data.border_bottom_right_corner + 'px'
	});
	// pop position
	var pos = get_pop_position(pop_position, div);
	$('#' + div).css({'top': pos.top, 'left': pos.left});

	// create pop elements
	create_pop_elements(div, pop_objects);
	pop_id_auto_inc++;
};
var create_pop_elements = function(div, pop_objects)
{
	for (i = 0; i < pop_objects.length; i++)
	{
		var el_sub_html;
		var obj = pop_objects[i];
		if (obj != null)
		{
			var el_full_id = 'vidlock-pop-' + pop_id_auto_inc + '-element-' + obj.id;
			if (obj.type == 'text')
			{
				el_sub_html = un_htmlspecialchars_js(obj.html);
			}
			else if (obj.type == 'image')
			{
				if (obj.url == "")
				{
					el_sub_html = '<img src="' + obj.img_src + '" width="100%" height="100%" alt="" />';
				}
				else
				{
					el_sub_html = '<a href="track.php?token=' + token + '&track=clicks&campaign_id=' + campaign_id + '&url=' + encodeURIComponent(obj.url) + '"><img src="' + obj.img_src + '" width="100%" height="100%" alt="" border="0" /></a>';
				}
			}
			else if (obj.type == 'cta_button')
			{
				el_sub_html = '<div class="vidlock-element-cta-button"><table style="width: 100%; height: 100%; border: 0; padding 0; margin: 0;"><tr><td valign="middle">' + un_htmlspecialchars_js(obj.cta_text) + '</td></tr></table></div>';
			}
			else if (obj.type == 'form_field')
			{
				el_sub_html = '<div class="vidlock-element-field-container"><input type="text" placeholder="' + un_htmlspecialchars_js(obj.placeholder) + '" /></div>';
			}
			else if (obj.type == 'youtube_video')
			{
				el_sub_html = '<iframe width="100%" height="100%" src="http://www.youtube.com/embed/' + obj.video_id + (obj.autoplay == 'yes' ? '?autoplay=1' : '') + '" frameborder="0" allowFullScreen></iframe>';
			}
			else if (obj.type == 'html_code')
			{
				el_sub_html = '<div class="html_code">' + un_htmlspecialchars_js(obj.html_code) + '</div>';
			}
			var el_html = '<div id="' + el_full_id + '">'
						+ '    <div class="vidlock-element-content">'
						+ '        ' + el_sub_html
						+ '    </div>'
						+ '</div>';
			$('#' + div).append(el_html);
			$('#' + el_full_id).css({
				'z-index': obj.zindex,
				position: 'absolute',
				left: obj.x,
				top: obj.y,
				width: obj.width,
				height: obj.height
			});

			// apply style to elements
			if (obj.type == 'text')
			{
				$('#' + el_full_id).css('backgroundColor', obj.background);
			}
			else if (obj.type == 'image')
			{
				// nothing to do for the image
			}
			else if (obj.type == 'cta_button')
			{
				$('#' + el_full_id + ' .vidlock-element-cta-button').css({
					'background-color': obj.background,
					'border-width': obj.border_size,
					'border-style': 'solid',
					'border-color': obj.border_color,
					'color': obj.color,
					'font-weight': obj.font_weight,
					'font-size': obj.font_size + 'pt',
					'-moz-border-radius-topleft': obj.border_top_left_corner + 'px', '-webkit-border-top-left-radius': obj.border_top_left_corner + 'px', 'border-top-left-radius': obj.border_top_left_corner + 'px',
					'-moz-border-radius-topright': obj.border_top_right_corner + 'px', '-webkit-border-top-right-radius': obj.border_top_right_corner + 'px', 'border-top-right-radius': obj.border_top_right_corner + 'px',
					'-moz-border-radius-bottomleft': obj.border_bottom_left_corner + 'px', '-webkit-border-bottom-left-radius': obj.border_bottom_left_corner + 'px', 'border-bottom-left-radius': obj.border_bottom_left_corner + 'px',
					'-moz-border-radius-bottomright': obj.border_bottom_right_corner + 'px', '-webkit-border-bottom-right-radius': obj.border_bottom_right_corner + 'px', 'border-bottom-right-radius': obj.border_bottom_right_corner + 'px'
				});
				if (obj.action == 'submit')
				{
					$('#' + el_full_id).addClass('cta_submit_form'); // the class "cta_submit_form" is not exist, just to point that button is for submit form
				}
				else
				{
					$('#' + el_full_id).addClass('cta_go_to_url').attr('rel', obj.url);
				}
			}
			else if (obj.type == 'form_field')
			{
				$('#' + el_full_id + ' .vidlock-element-field-container').css({
					'border-width': obj.border_size,
					'border-style': 'solid',
					'border-color': obj.border_color,
					'-moz-border-radius-topleft': obj.border_top_left_corner + 'px', '-webkit-border-top-left-radius': obj.border_top_left_corner + 'px', 'border-top-left-radius': obj.border_top_left_corner + 'px',
					'-moz-border-radius-topright': obj.border_top_right_corner + 'px', '-webkit-border-top-right-radius': obj.border_top_right_corner + 'px', 'border-top-right-radius': obj.border_top_right_corner + 'px',
					'-moz-border-radius-bottomleft': obj.border_bottom_left_corner + 'px', '-webkit-border-bottom-left-radius': obj.border_bottom_left_corner + 'px', 'border-bottom-left-radius': obj.border_bottom_left_corner + 'px',
					'-moz-border-radius-bottomright': obj.border_bottom_right_corner + 'px', '-webkit-border-bottom-right-radius': obj.border_bottom_right_corner + 'px', 'border-bottom-right-radius': obj.border_bottom_right_corner + 'px'
				});
				if (name_object_id == obj.id)
				{
					$('#' + el_full_id + ' .vidlock-element-field-container').find('input').attr('id', 'cpengage_name');
				}
				if (email_object_id == obj.id)
				{
					$('#' + el_full_id + ' .vidlock-element-field-container').find('input').attr('id', 'cpengage_email');
				}
			}
			else if (obj.type == 'youtube_video')
			{
				// nothing to do for the youtube video
			}
		}
	}
};
var get_pop_position = function(position, div)
{
	var pop_top = pop_left = 0;
	// top left
	if (position == 'topleft')
	{
		pop_top = 30;
		pop_left = 30;
	}
	// top right
	if (position == 'topright')
	{
		pop_top = 30;
		pop_left = $(window).width() - $('#' + div).width() - 30;
	}
	// top center
	if (position == 'topcenter')
	{
		pop_top = 30;
		pop_left = ($(window).width() / 2) - ( $('#' + div).width() / 2);
	}
	// bottom left
	if (position == 'bottomleft')
	{
		pop_top = $(window).height() - $('#' + div).height() - 30;
		pop_left = 30;
	}
	// bottom right
	if (position == 'bottomright')
	{
		pop_top = $(window).height() - $('#' + div).height() - 30;
		pop_left = $(window).width() - $('#' + div).width() - 30;
	}
	// bottom center
	if (position == 'bottomcenter')
	{
		pop_top = $(window).height() - $('#' + div).height() - 30;
		pop_left = ($(window).width() / 2) - ( $('#' + div).width() / 2);
	}
	// middle left
	if (position == 'middleleft')
	{
		pop_top = ($(window).height() / 2) - ( $('#' + div).height() / 2) + $(window).scrollTop();
		pop_left = 30;
	}
	// middle center
	if (position == 'middlecenter')
	{
		pop_top = ($(window).height() / 2) - ( $('#' + div).height() / 2) + $(window).scrollTop();
		pop_left = ($(window).width() / 2) - ( $('#' + div).width() / 2);
	}
	// middle right
	if (position == 'middleright')
	{
		pop_top = ($(window).height() / 2) - ( $('#' + div).height() / 2) + $(window).scrollTop();
		pop_left = $(window).width() - $('#' + div).width() - 30;
	}
	return {'top': pop_top, 'left': pop_left};
};
var un_htmlspecialchars_js = function(text)
{
	return text
		.replace(/&cpengage_amp;/g, '&')
		.replace(/&cpengage_lt;/g, '<')
		.replace(/&cpengage_gt;/g, '>')
		.replace(/&cpengage_quot;/g, '"')
		.replace(/&#cpengage_039;/g, "'");
};
var is_valid_email = function(email)
{
	var re = /^([\w-]+(?:\.[\w-]+)*)@((?:[\w-]+\.)*\w[\w-]{0,66})\.([a-z]{2,6}(?:\.[a-z]{2})?)$/i;
	return re.test(email);
};

// # CTA Button Submit Form
var ajax_request_sent = false;
$(document).on('click', '.vidlock-element-content', function(){
	if (ajax_request_sent)
	{
		return false;
	}
	var el_parent = $(this).parent();
	var is_submit_form = el_parent.hasClass('cta_submit_form');
	var is_go_to_url = el_parent.hasClass('cta_go_to_url');
	var name_val = '';
	var email_val = '';
	if (is_submit_form)
	{
		// check fields
		// name
		if (name_object_id > 0)
		{
			var name_element = $('#cpengage_name');
			if (name_element.length == 0)
			{
				alert('# Error (ARC_NO_NAME_FIELD):\nNo Name Field exist, please edit this pop from pop builder!');
				return false;
			}

			// check name value
			name_val = name_element.val();
			if (name_val.length == 0)
			{
				alert('Please enter your name!');
				name_element.focus();
				return false;
			}
			if (name_val.length < 3)
			{
				alert('Your name must be contain more than 3 characters!');
				name_element.focus();
				return false;
			}
		}
		// email
		if (email_object_id > 0)
		{
			var email_element = $('#cpengage_email');
			if (email_element.length == 0)
			{
				alert('# Error (ARC_NO_EMAIL_FIELD):\nNo Email Field exist, please edit this pop from pop builder!');
				return false;
			}

			// check email value
			email_val = email_element.val();
			if (email_val.length == 0)
			{
				alert('Please enter your Email!');
				email_element.focus();
				return false;
			}
			if (!is_valid_email(email_val))
			{
				alert('The email you entered is not valid!');
				email_element.focus();
				return false;
			}
		}
		// submit an AJAX request
		ajax_request_sent = true;
		window.onbeforeunload = null;
		show_loader();
	    var request = jQuery.ajax({
	        url: baseurl+"subscribe.php",
	        type: "post",
	        dataType: "json",
	        // pop_for_email_subscriptions is arc_id
	        data: {'email': email_val, 'name': name_val, 'campaign_id': campaign_id, 'arc_id': pop_for_email_subscriptions}
	    });
	    request.done(function (response, textStatus, jqXHR){
	        // setTimeout(function(){
	        	if (typeof response.error !== 'undefined')
	        	{
	        		alert(response.error);
	        		$('#pop, #pop-background, #thankyoumsg, #thankyoumsg-background').hide();
	        	}
	        	else
	        	{
		        	if (thankyoumsg_type == 'text')
		        	{
		        		show_success_box();
		        	}
		        	else
		        	{
		        		document.write('Redirecting..');
		        		document.location = thankyoumsg_redirect_url;
		        	}
	        	}
	        	ajax_request_sent = false;
	        // }, 2000);
	    });
	    request.fail(function (jqXHR, textStatus, errorThrown){
	        alert(textStatus);
	    });
	}
	else if (is_go_to_url)
	{
		window.onbeforeunload = null;
		document.location = 'track.php?token=' + token + '&track=clicks&campaign_id=' + campaign_id + '&url=' + encodeURIComponent(el_parent.attr('rel'));
	}
});
var show_loader = function()
{
	var pop_offset = $('#pop').offset();
	var top = pop_offset.top + ( ( ($('#pop').height() / 2) - $('#thankyoumsg').height() / 2) + $(window).scrollTop() );
	var left = pop_offset.left + ( ($('#pop').width() / 2) - ($('#thankyoumsg').width() / 2) );
	$('#thankyoumsg-background').show();
	$('#thankyoumsg').css({'top': top, 'left': left}).show();
	$('#thankyoumsg #loader').show(400);
};
var show_success_box = function()
{
	var pop_offset = $('#pop').offset();
	$('#thankyoumsg #loader').hide();
	$('#thankyoumsg').css({'width': 240, 'height': 190});
	$('#thankyoumsg #success').show();
	var top = pop_offset.top + ( ( ($('#pop').height() / 2) - $('#thankyoumsg').height() / 2) + $(window).scrollTop() );
	var left = pop_offset.left + ( ($('#pop').width() / 2) - ($('#thankyoumsg').width() / 2) );
	$('#thankyoumsg').css({'top': top, 'left': left});
};
var go_track_view = function()
{
	// check if unique view
	var is_unique = 0;
	var view_cookie_name = 'cpecid' + campaign_id;
	var view_in_cookie = getCookie(view_cookie_name);
	if (view_in_cookie != cpengage_ip)
	{
		createCookie(view_cookie_name, cpengage_ip, 30*6);
		is_unique = 1;
	}

	// do an AJAX request
	var request = jQuery.ajax({
	    url: baseurl+"track.php",
	    type: "post",
	    dataType: "text",
	    data: {'token': token, 'track': 'views', 'is_unique': is_unique, 'campaign_id': campaign_id}
	});
    request.done(function (response, textStatus, jqXHR){
         alert('view tracked: ' + response);
    });
};

// cookie functions
// by: http://stackoverflow.com/questions/4825683/how-do-i-create-and-read-a-value-from-cookie
var createCookie = function(name, value, days) {
    var expires;
    if (days) {
        var date = new Date();
        date.setTime(date.getTime() + (days * 24 * 60 * 60 * 1000));
        expires = "; expires=" + date.toGMTString();
    }
    else {
        expires = "";
    }
    document.cookie = name + "=" + value + expires + "; path=/";
};
var getCookie = function(c_name) {
    if (document.cookie.length > 0) {
        c_start = document.cookie.indexOf(c_name + "=");
        if (c_start != -1) {
            c_start = c_start + c_name.length + 1;
            c_end = document.cookie.indexOf(";", c_start);
            if (c_end == -1) {
                c_end = document.cookie.length;
            }
            return unescape(document.cookie.substring(c_start, c_end));
        }
    }
    return "";
};

// # Document is ready :)
$(document).ready(function(){
	// # Create primary pop
	create_new_pop('pop', pop_data);

	// # Check for errors - must be below create_new_pop
	if (pop_for_email_subscriptions > 0) // pop for email subscriptions so email field is important
	{
		if (email_object_id == 0)
		{
			alert('# Error (ARC_NO_EMAIL):\nThis campaign use an Autoresponder Campaign and the system not found any Email Field inside the pop.\n# To hide this error:\nPlease go back and edit the pop using Pop Builder and add an Email Field then mark it as Email.');
		}
		if (name_object_id > 0)
		{
			var cpengage_name = $('#cpengage_name');
			if (cpengage_name.length == 0)
			{
				alert('# Error (ARC_NO_NAME_FIELD):\nNo Name Field exist, please edit this pop from pop builder!');
			}
		}
		if (email_object_id > 0)
		{
			var cpengage_email = $('#cpengage_email');
			if (cpengage_email.length == 0)
			{
				alert('# Error (ARC_NO_EMAIL_FIELD):\nNo Email Field exist, please edit this pop from pop builder!');
			}
		}
	}
	if (pop_for_email_subscriptions == 0) // pop is not for email subscriptions
	{
		if (name_object_id > 0)
		{
			alert('# Error (NO_ARC_NAME_FIELD):\nThis campaign doesn\'t use any Autoresponder Campaign and the system found a Name Field inside the pop.\n# To hide this error:\nPlease go back and edit the pop using Pop Builder and remove the Name Field or mark it as Normal.');
		}
		if (email_object_id > 0)
		{
			alert('# Error (NO_ARC_EMAIL_FIELD):\nThis campaign doesn\'t use any Autoresponder Campaign and the system found an Email Field inside the pop.\n# To hide this error:\nPlease go back and edit the pop using Pop Builder and remove the Email Field or mark it as Normal.');
		}
	}
	for (i = 0; i < pop_objects.length; i++)
	{
		var obj = pop_objects[i];
		if (obj.type == 'cta_button')
		{
			if (obj.action == 'submit' && pop_for_email_subscriptions == 0) // pop is not for email subscriptions
			{
				alert('# Error (NO_ARC_CTA_SUBMIT):\nThis campaign doesn\'t use any Autoresponder Campaign and the system found a CTA Button that submit subscription form inside the pop.\n# To hide this error:\nPlease go back and edit the pop using Pop Builder and remove the CTA Button or change its action to Link.');
			}
		}
	}

	// # Show the pop when must be shown
	// popup
	if (pop_type == 'popup')
	{
		go_track_view();
		$('#pop-background, #pop, #pop-close').show();
	}
	// pop wait
	var pop_up_displayed = false;
	if (pop_type == 'popwait')
	{
		$(document).on('mouseleave', function(e){
		    if (!pop_up_displayed)
		    {
		    	go_track_view();
		    	$('#pop-background, #pop, #pop-close').show();
		    	pop_up_displayed = true;
		    }
		});
	}
	// pop last chance
	if (pop_type == 'poplastchance')
	{
		window.onbeforeunload = function(e)
		{
			go_track_view();
			window.onbeforeunload = null;
		    $('#campaign-iframe').hide();
		    $('#pop').show();
		    // $('#pop').css({'position': 'static', 'margin-left': 'auto', 'margin-right': 'auto'}).show();
		    return 'Waiiiit!';
		};
	}
	// pop fix
	if (pop_type == 'popfix')
	{
		go_track_view();
		$('#pop, #pop-close').show();
	}

	// # Display the pop again when the user close it
	// close the pop
	var closed_count = 0;
	$('#pop-close').click(function(){
		$('#pop').hide();
		$('#pop-background').hide();
		if (closed_count == 0)
		{
			setTimeout(function(){
				$('#pop').show();
				if (pop_type == 'popup' || pop_type == 'popwait')
				{
					$('#pop-background').show();
				}
			}, pop_duration_btwn_close * 1000);
		}
		closed_count++;
	});
	// close all
	$('#thankyou-msg-close').click(function(){
		$('#pop, #pop-background, #thankyoumsg, #thankyoumsg-background').hide();
	});
});